package cz.cvut.fel.pr2.du3.interfaces;

import java.io.IOException;

/**
 *
 * @author balikm1
 */
public interface IStorage {
    
    /**
     * 
     * @return true if storage is read only
     */
    boolean isReadOnly();
    
    /**
     * Sets the read only status of the storage
     * 
     * @param readOnly true for read only storage
     */
    void setReadOnly(boolean readOnly);
    
    /**
     * 
     * @return true if storage data is corrupt
     */
    boolean isCorrupt();
    
    /**
     * Sets the data validity status of the storage
     * 
     * @param corrupt true for corrupt data status
     */
    void setCorrupt(boolean corrupt);
    
    /**
     * Returns capacity of the data storage
     * 
     * @return number of objects
     */
    int getCapacity();
    
    /**
     * Writes an object into the storage
     * @param o object to write
     * @throws IOException in case of full or read only storage
     */
    void write(IStorable o) throws IOException;
    
    /**
     * Reads an object from the storage at the given index
     * @param index reading position
     * @return object from the storage
     * @throws IOException in case of invalid index range, empty position or corrupt data
     */
    IStorable read(int index) throws IOException;
}
